/* src/include/platform_defs.h.  Generated automatically by configure.  */
/*
 * Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston MA 02111-1307, USA.
 * 
 * Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
 * Mountain View, CA  94043, or:
 * 
 * http://www.sgi.com 
 * 
 * For further information regarding this notice, see: 
 * 
 * http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
 *
 * $Id: platform_defs.h.in,v 1.22 2000/07/24 02:58:52 max Exp $
 * 
 * @configure_input@
 */

#ifndef _PLATFORM_DEFS_H
#define _PLATFORM_DEFS_H

#ifdef __cplusplus      
extern "C" {
#endif

/*
 * For Linux impl.h, pmapi.h and pmapi_dev.h were combinied
 * and then split into pmapi.h and pmapi_mon.h. The following
 * three macros can be used to conditionally include the appropriate
 * headers for code portability.
 */
/* #define HAVE_IMPL_H */	/* LINUX does not have this header */
/* #define HAVE_PMAPI_DEV_H */	/* LINUX does not have this header */
#define HAVE_PMAPI_MON_H	/* IRIX does not have this header */

/*
 * The type of timestamps in struct stat: either HAVE_STAT_TIMESPEC,
 * HAVE_STAT_TIMESTRUC or HAVE_STAT_TIME_T
 */
/* #undef HAVE_STAT_TIMESTRUC */
/* #undef HAVE_STAT_TIMESPEC */
#define HAVE_STAT_TIME_T 1

/* HAVE_ST_MTIME if stat.st_mtime has an ``e'' on the end */
#define HAVE_ST_MTIME_WITH_E 1

/* if your compiler supports LL sufix on 64 bit int constants */
#define HAVE_CONST_LONGLONG 1 

/* if flexlm is available */
/* #undef HAVE_FLEXLM */

/*
 * HAVE_UNDERBAR_ENVIRON if extern char **_environ is defined
 * (else extern char **environ will be used)
 */
#define HAVE_UNDERBAR_ENVIRON 1

/*
 * If the pointer-to-function arguments to scandir()
 * are (*scanfn)(const struct dirent *dep)
 * Otherwise ``const'' will be omitted.
 */
/* #undef HAVE_CONST_DIRENT */

/*
 * If getopt() needs $POSIXLY_CORRECT set in the environment to work
 * correctly, specifically to not treat -x as an option when foo is
 * invoked with the arguments "arg -x"
 */
#define HAVE_GETOPT_NEEDS_POSIXLY_CORRECT 1

/* Defined if printf %p -> 0x prefix for value */
#define HAVE_PRINTF_P_PFX 1
#ifdef HAVE_PRINTF_P_PFX
#define PRINTF_P_PFX ""
#else
#define PRINTF_P_PFX "0x"
#endif

/* Defined if bit fields are allocated left-to-right within a word */
/* #undef HAVE_BITFIELDS_LTOR */

/* if compiler can cast __uint64_t to double */
#define HAVE_CAST_U64_DOUBLE 1

/* long and pointer must be either 32 bit or 64 bit */
/* #undef HAVE_64BIT_LONG */
#define HAVE_32BIT_LONG 1
#define HAVE_32BIT_PTR 1
/* #undef HAVE_64BIT_PTR */

/* Define if header file is available */
#define HAVE_FCNTL_H 1
#define HAVE_LIMITS_H 1
#define HAVE_MALLOC_H 1
#define HAVE_STRINGS_H 1
#define HAVE_SYS_TIME_H 1
#define HAVE_SYSLOG_H 1
#define HAVE_UNISTD_H 1
#define HAVE_SCHED_H 1
#define HAVE_TERMIOS_H 1
#define HAVE_DLFCN_H 1
/* #undef HAVE_IEEEFP_H */
#define HAVE_ENDIAN_H 1
/* #undef HAVE_SYS_ENDIAN_H */
#define HAVE_PTHREAD_H 1

/* HAVE_NETWORK_BYTEORDER for big endian systems (not Intel) */
#if defined(HAVE_ENDIAN_H)
#include <endian.h>
#elif defined(HAVE_SYS_ENDIAN_H)
#include <sys/endian.h>
#endif
#if defined(BYTE_ORDER)
#if BYTE_ORDER == BIG_ENDIAN
#define HAVE_NETWORK_BYTEORDER
#endif
#endif

/* define if libc functions are available */
#define HAVE_GETCWD 1
#define HAVE_GETHOSTNAME 1
#define HAVE_GETTIMEOFDAY 1
#define HAVE_MKTIME 1
#define HAVE_PUTENV 1
#define HAVE_SELECT 1
#define HAVE_SOCKET 1
#define HAVE_STRDUP 1
#define HAVE_STRERROR 1
#define HAVE_STRTOD 1
#define HAVE_STRTOL 1
#define HAVE_UNAME 1
#define HAVE_WAITPID 1
#define HAVE_ATEXIT 1
/* #undef HAVE_READDIR64 */
#define HAVE_WAIT3 1
#define HAVE_SBRK 1
#define HAVE_BRK 1
#define HAVE___CLONE 1
/* #undef HAVE_SPROC */ 
#define HAVE_SIGNAL 1 
#define HAVE_TCGETATTR 1
#define HAVE_HSTRERROR 1
/* #undef HAVE_DLOPEN */
#define HAVE_ISNANF 1
/* #undef HAVE_ISNAND */
/* #undef HAVE_SHL */
/* #undef HAVE_SGINAP */
#define HAVE_USLEEP 1
/* #undef HAVE_OSERROR */
/* #undef HAVE_SETOSERROR */
/* #undef HAVE_ISNAND */
/* #undef HAVE_FLOG10 */
#define HAVE_SIGHOLD 1
#define HAVE_SIGRELSE 1
#define HAVE_PRCTL 1
/* #undef HAVE_REGEX */
/* #undef HAVE_REGCMP */
#define HAVE_REGEXEC 1
#define HAVE_REGCOMP 1

/* if termio signals are supported */
#ifdef HAVE_TERMIOS_H
#ifdef HAVE_TCGETATTR
#define HAVE_TERMIO_SIGNALS
#endif
#endif

/* if dlopen et al are available */
#define HAVE_DLFCN 1
#ifdef HAVE_LIBDL
#ifndef HAVE_DLFCN
#define HAVE_DLFCN
#endif
#endif

/* if HPUX style shl_* shared library functions are available */
#ifdef HAVE_SHL_LOAD
#define HAVE_SHL
#endif

/* if the /proc pseudo filesystem exists */
#define HAVE_PROCFS 1

/* if the /proc/pinfo/<pid> should be used (IRIX only?) */
/* #undef HAVE_PROCFS_PINFO */

#ifndef ULONGLONG_MAX 
#define ULONGLONG_MAX (__uint64_t)18446744073709551615ULL
#endif

#ifndef LONGLONG_MAX 
#define LONGLONG_MAX (__int64_t)9223372036854775807LL
#endif

/* some types only known by some compilers */
#define uint_t u_int32_t
/* #undef __int32_t */
/* #undef __uint32_t */
/* #undef __int64_t */
/* #undef __uint64_t */

/* Check is __psint_t is set to smth meaningful */
/* #undef HAVE___PSINT_T */
#ifndef HAVE___PSINT_T 
#ifdef HAVE_32BIT_PTR
typedef int __psint_t;
#elif defined HAVE_64BIT_PTR
#ifdef HAVE_64BIT_LONG
typedef long __psint_t;
#else
/* This is a very strange architecture, which has 64 bit pointers but
 * not 64 bit longs. So, I'd just punt here and assume long long is Ok */
typedef long long __psint_t;
#endif
#else
#error Unknown pointer size
#endif
#endif

/* posix version of the bsd MAXNAMELEN macro */
#ifndef MAXNAMELEN
#define MAXNAMELEN FILENAME_MAX
#endif

#ifndef HAVE_SGINAP
#ifdef HAVE_USLEEP
#define sginap(x) (long)(usleep(1000000 * x / CLK_TCK), 0)
#else
#define sginap(x) sleep(x/CLK_TCK)
#endif
#endif

#ifndef HAVE_OSERROR
#define oserror() errno
#endif

#ifndef HAVE_SETOSERROR
#define setoserror(e) errno = e
#endif

#ifndef HAVE_ISNAND
#define isnand(x) (double)isnanf((float)x)
#endif

#ifndef HAVE_FLOG10
#if !defined(flog10)
#define flog10(x) (float)log10((double)x)
#endif
#endif

#if !defined(WORD_BIT)
#define WORD_BIT 32
#endif

/* #undef HAVE_SIGPF */
#ifndef HAVE_SIGPF
/* The return type of signal() */
typedef void (*SIG_PF) (int);
#endif

/* #undef HAVE_WAIT_INCLUDES_SIGNAL */
#ifndef HAVE_WAIT_INCLUDES_SIGNAL
#include <signal.h>
#endif

#if !defined(DBM)
#define DBM void
#endif

/* #undef HAVE_PR_TERMCHILD */
#define HAVE_PR_SET_PDEATHSIG 1

#define HAVE_PTHREAD_MUTEX_T 1

/* #undef HAVE_ALTZONE */
#define HAVE_STRFTIME_z 1

#ifdef __cplusplus      
}
#endif

#endif /* _PLATFORM_DEFS_H */
