/*
 * Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston MA 02111-1307, USA.
 * 
 * Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
 * Mountain View, CA  94043, or:
 * 
 * http://www.sgi.com 
 * 
 * For further information regarding this notice, see: 
 * 
 * http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
 */

/*
 * the txmon shm segment
 *
 * control comes at the beginning, with index[] expanded to match the
 * number of transaction types (control->n_tx)
 *
 * then follows one stat_t per transaction type, subject to the
 * constraint that each stat_t is hardware cache aligned to avoid
 * anti-social bus traffic
 *
 * $Id: txmon.h,v 2.5 2000/04/05 18:48:07 kenmcd Exp $
 */

typedef struct {
    int		level;		/* controls stats collection levels */
    int		n_tx;		/* # of tx types */
    int		index[1];	/* will be expanded when allocated */
} control_t;

static control_t	*control;

#define MAXNAMESIZE 20

typedef struct {

    /* managed by txmon PMDA ... do not fiddle with these! */
    char		type[MAXNAMESIZE];	/* tx type name */
    unsigned int	reset_count;	/* tx count @ last reset */

    /* initialized and then read by txmon PMDA, updated by txrecord */
    unsigned int	count;		/* tx count since epoch */
    float		max_time;	/* maximum elapsed time */
    double		sum_time;	/* aggregate elapsed time */
} stat_t;

/* arbitrary shm key */
#define KEY (key_t)0xdeadbeef
