#! /bin/sh
#
# Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
# 
# This program is distributed in the hope that it would be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# 
# Further, this software is distributed without any warranty that it is
# free of the rightful claim of any third person regarding infringement
# or the like.  Any license provided herein, whether implied or
# otherwise, applies only to this software file.  Patent licenses, if
# any, provided herein do not apply to combinations of this program with
# other software, or any other product whatsoever.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write the Free Software Foundation, Inc., 59
# Temple Place - Suite 330, Boston MA 02111-1307, USA.
# 
# Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
# Mountain View, CA  94043, or:
# 
# http://www.sgi.com 
# 
# For further information regarding this notice, see: 
# 
# http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
#
# $Id: weblogconv.sh,v 1.6 2000/04/05 18:48:13 kenmcd Exp $
#

#
# weblogconv: convert weblog.conf files to posix regex
#

progname=$0

if [ $# -gt 0 -a "$1" = "-?" ]; then
    echo "Usage: $progname infile [outfile]"
    exit 0
fi

if [ $# -gt 2 ]; then
    echo "$progname: Too many arguments."
    exit 1
fi

if [ $# -lt 1 ] ; then
    infile=""
else	
    infile=$1
fi

if [ $# -lt 2 ]; then
    outfile=""
else
    outfile="> $2"
fi

if [ -n "$infile" -a ! -r "$infile" ]; then
    echo "$progname: cannot read $infile"
    exit 1
fi


sed  $infile \
    -e '/)\$[01]/!s/^regex[ \t][ \t]*\([^ \t][^ \t]*\)[ \t][ \t]*/regex_posix \1 - /' \
    -e 's/^regex[ \t][ \t]*\([^ \t][^ \t]*\)[ \t][ \t]*\(.*$0.*$1.*\)/regex_posix \1 method,size \2/' \
    -e 's/^regex[ \t][ \t]*\([^ \t][^ \t]*\)[ \t][ \t]*\(.*$1.*$0.*\)/regex_posix \1 size,method \2/' \
    -e 's/)$0/)/g' \
    -e 's/)$1/)/g' | eval cat $outfile

exit 0
